/*
mixedvb Version 0.1.0 - Mixed 6x6 Volleyball
Copyright (C) 2002  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include "rnd.h"
#include "tree.h"

#define MAX 900
#define MAXCT 150

int roundtbl[161] = { 2,           /*         6 */
   3,3,3,3,4,4,4,4,                /*  12 -  54 */
   5,5,5,5,6,6,6,6,                /*  60 - 102 */
   6,7,7,7,7,7,7,8,                /* 108 - 150 */
   8,8,8,8,8,8,8,8,                /* 156 - 198 */
   8,9,9,9,9,9,9,9,                /* 204 - 246 */
   9,9,9,9,9,9,9,9,                /* 252 - 294 */
   10,10,10,10,10,10,10,10,        /* 300 - 342 */
   10,10,10,10,10,10,10,10,        /* 348 - 390 */
   10,10,10,10,10,10,10,10,        /* 396 - 438 */
   11,11,11,11,11,11,11,11,        /* 444 - 486 */
   11,11,11,11,11,11,11,11,        /* 492 - 534 */
   11,11,11,11,11,11,11,11,        /* 540 - 582 */
   12,12,12,12,12,12,12,12,        /* 588 - 630 */
   12,12,12,12,12,12,12,12,        /* 636 - 678 */
   12,12,12,12,12,12,12,12,        /* 684 - 726 */
   13,13,13,13,13,13,13,13,        /* 732 - 774 */
   13,13,13,13,13,13,13,13,        /* 780 - 822 */
   13,13,13,13,13,13,13,13,        /* 828 - 870 */
   14,14,14,14,14,14,14,14,        /* 876 - 918 */
   14,14,14,14,14,14,14,14};       /*           */

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage: %s pairs\n", pgm);
   fprintf(stderr,"Where pairs is divisible "
      "by 6 between 6 and %d\n", MAX);
   fprintf(stderr,"Example:  %s 20\n", pgm);
   exit(1);
   } /* putstx */

int main(argc,argv)
int argc;
char **argv;
   {
   int i,j,indx,rndindx;
   int ch;
   int court;
   int north1,north2,north3;
   int south1,south2,south3;
   int east1,east2,east3;
   int west1,west2,west3;
   int round,maxround;
   int uscount,themcount,paircount;
   int id;
   int rslt;
   int try,maxtry;
   int rcnthsth1,rcnthsth2,rcnthsth3;
   int tmp;
   int totpairs;
   int totplayers;
   int totcourts;
   int  us[MAX+16];
   int  them[MAX+16];
   prfmt *new;
   prfmt *rtns;
   prfmt *rtew;
   prfmt *rth;
   char rndlst[MAXCT*MAXCT][38];

   if (argc != 2) putstx(*argv);
   totpairs = atoi(*(argv+1));
   if (totpairs < 6 || totpairs > MAX) putstx(*argv);
   if (totpairs % 6 != 0)
      {
      fprintf(stderr,"Pairs must be divisible by 6\n");
      putstx(*argv);
      } /* if total pairs not divisible by 6 */
   sd = (unsigned char *) initrnd();
   rtns = (prfmt *) initnode(0,0);
   rtew = (prfmt *) initnode(0,0);
   rth  = (prfmt *) initnode(0,0);
   strcpy(rtns->pair,"zzzzzz");
   strcpy(rtew->pair,"zzzzzz");
   strcpy(rth->pair,"zzzzzz");
   totplayers = totpairs;
   totcourts = totpairs / 6;
   maxround = -999999;
   id = 0;
   while (1) /* group of rounds */
      {
      id++;
      if (rth->left  != NULL) freetree(rth->left);
      rth->left  = NULL;
      rndindx = round = 0;
      while (round < totplayers) /* for each round */
         {
         round++;
         if (rtns->left != NULL) freetree(rtns->left);
         if (rtew->left != NULL) freetree(rtew->left);
         rtns->left = NULL;
         rtew->left = NULL;
         for (i=0;i<totpairs;i++)
            {
            us[i] = them[i] = i;
            } /* init us and them rosters */
         for (i=totpairs;i<totpairs+1;i++)
            {
            us[i] = them[i] = -9999;
            } /* init us and them rosters */
         uscount = themcount = totpairs;
         court = 0;
         while (court < totcourts)
            {
            court++;
            paircount = rslt = 0;
            rcnthsth1 = rcnthsth2 = rcnthsth3 = 1;
            maxtry = uscount << 5;
            try = 0;
            while ((rcnthsth1 || rcnthsth2 || rcnthsth3)
               && uscount > 5
               && themcount > 5
               && try < maxtry)
               {
               try++;
               indx = rndnum(uscount,sd);
               north1 = us[indx];
               while (indx < uscount)
                  {
                  us[indx] = us[indx+1];
                  indx++;
                  } /* shift left */
               uscount--;
               if (uscount < 5)
                  {
                  fprintf(stderr,"Side A Out of "
                     "north/south (north1)\n");
                  exit(1);
                  } /* if out of north/south */
               indx = rndnum(uscount,sd);
               north2 = us[indx];
               while (indx < uscount)
                  {
                  us[indx] = us[indx+1];
                  indx++;
                  } /* shift left */
               uscount--;
               if (uscount < 4)
                  {
                  fprintf(stderr,"Side A Out of "
                     "north/south (north2)\n");
                  exit(1);
                  } /* if out of north/south */
               indx = rndnum(uscount,sd);
               north3 = us[indx];
               while (indx < uscount)
                  {
                  us[indx] = us[indx+1];
                  indx++;
                  } /* shift left */
               uscount--;
               if (uscount < 3)
                  {
                  fprintf(stderr,"Side A Out of "
                     "north/south (north3)\n");
                  exit(1);
                  } /* if out of north/south */
               indx = rndnum(themcount,sd);
               south1 = them[indx];
               while (indx < themcount)
                  {
                  them[indx] = them[indx+1];
                  indx++;
                  } /* shift left */
               themcount--;
               if (themcount < 5)
                  {
                  fprintf(stderr,"Side A Out of "
                     "north/south (south1)\n");
                  exit(1);
                  } /* if out of north/south */

               rcnthsth1 = srch(north1,south1,rth);
               rcnthsth2 = srch(north2,south1,rth);
               rcnthsth3 = srch(north3,south1,rth);
               if (rcnthsth1 || rcnthsth2 || rcnthsth3)
                  {
                  us[uscount++] = north1;
                  us[uscount++] = north2;
                  us[uscount++] = north3;
                  us[uscount] = -9999;
                  them[themcount++] = south1;
                  them[themcount] = -9999;
                  } /* if duplicate */
               if (uscount > totplayers)
                  {
                  fprintf(stderr,"Side A North "
                     "overflow\n");
                  exit(1);
                  } /* overflow */
               if (themcount > totplayers)
                  {
                  fprintf(stderr,"Side A South1 "
                     "overflow\n");
                  exit(1);
                  } /* overflow */
               } /* north/south loop */
            if (try >= maxtry) break;
            rcnthsth1 = rcnthsth2 = rcnthsth3 = 1;
            maxtry = themcount << 7;
            try = 0;
            while ((rcnthsth1 || rcnthsth2 || rcnthsth3)
               && uscount > 2
               && themcount > 4
               && try < maxtry)
               {
               try++;
               indx = rndnum(themcount,sd);
               south2 = them[indx];
               while (indx < themcount)
                  {
                  them[indx] = them[indx+1];
                  indx++;
                  } /* shift left */
               themcount--;
               if (themcount < 4)
                  {
                  fprintf(stderr,"Side A Out of "
                     "north/south (south2)\n");
                  exit(1);
                  } /* if out of south2 */

               rcnthsth1 = srch(north1,south2,rth);
               rcnthsth2 = srch(north2,south2,rth);
               rcnthsth3 = srch(north3,south2,rth);
               if (rcnthsth1 || rcnthsth2 || rcnthsth3)
                  {
                  them[themcount++] = south2;
                  them[themcount] = -9999;
                  } /* if duplicate */
               if (themcount > totplayers)
                  {
                  fprintf(stderr,"Side A North/south2 "
                     "overflow\n");
                  exit(1);
                  } /* overflow */
               } /* south2 loop */
            if (try >= maxtry) break;
            rcnthsth1 = rcnthsth2 = rcnthsth3 = 1;
            maxtry = themcount << 9;
            try = 0;
            while ((rcnthsth1 || rcnthsth2 || rcnthsth3)
               && uscount > 2
               && themcount > 3
               && try < maxtry)
               {
               try++;
               indx = rndnum(themcount,sd);
               south3 = them[indx];
               while (indx < themcount)
                  {
                  them[indx] = them[indx+1];
                  indx++;
                  } /* shift left */
               themcount--;
               if (themcount < 3)
                  {
                  fprintf(stderr,"Side A Out of "
                     "north/south (south3)\n");
                  exit(1);
                  } /* if out of south3 */

               rcnthsth1 = srch(north1,south3,rth);
               rcnthsth2 = srch(north2,south3,rth);
               rcnthsth3 = srch(north3,south3,rth);
               if (rcnthsth1 || rcnthsth2 || rcnthsth3)
                  {
                  them[themcount++] = south3;
                  them[themcount] = -9999;
                  } /* if duplicate */
               if (themcount > totplayers)
                  {
                  fprintf(stderr,"Side A North/south3 "
                     "overflow\n");
                  exit(1);
                  } /* overflow */
               } /* south3 loop */
            if (try >= maxtry) break;

            if (!rcnthsth1 && !rcnthsth2 && !rcnthsth3)
               {
               new = (prfmt *) initnode(north1,south1);
               isrt(new,rth,id,round,court,111);
               new = (prfmt *) initnode(north1,south2);
               isrt(new,rth,id,round,court,112);
               new = (prfmt *) initnode(north1,south3);
               isrt(new,rth,id,round,court,113);
               new = (prfmt *) initnode(north2,south1);
               isrt(new,rth,id,round,court,121);
               new = (prfmt *) initnode(north2,south2);
               isrt(new,rth,id,round,court,122);
               new = (prfmt *) initnode(north2,south3);
               isrt(new,rth,id,round,court,123);
               new = (prfmt *) initnode(north3,south1);
               isrt(new,rth,id,round,court,131);
               new = (prfmt *) initnode(north3,south2);
               isrt(new,rth,id,round,court,132);
               new = (prfmt *) initnode(north3,south3);
               isrt(new,rth,id,round,court,133);
               sprintf(rndlst[rndindx++],
                  "%03d %03d 001 %03d %03d %03d %03d %03d %03d",
                  round, court,
                  north1, north2, north3,
                  south1, south2, south3);
               paircount = 1;
               } /* if successful court */
            else
               {
               break;
               } /* incomplete set */
            rcnthsth1 = rcnthsth2 = rcnthsth3 = 1;
            maxtry = uscount << 5;
            try = 0;
            while ((rcnthsth1 || rcnthsth2 || rcnthsth3)
               && uscount > 2
               && themcount > 2
               && try < maxtry)
               {
               try++;
               indx = rndnum(uscount,sd);
               north1 = us[indx];
               while (indx < uscount)
                  {
                  us[indx] = us[indx+1];
                  indx++;
                  } /* shift left */
               uscount--;
               if (uscount < 2)
                  {
                  fprintf(stderr,"Side B Out of "
                     "north/south (north1)\n");
                  exit(1);
                  } /* if out of north/south */
               indx = rndnum(uscount,sd);
               north2 = us[indx];
               while (indx < uscount)
                  {
                  us[indx] = us[indx+1];
                  indx++;
                  } /* shift left */
               uscount--;
               if (uscount < 1)
                  {
                  fprintf(stderr,"Side B Out of "
                     "north/south (north2)\n");
                  exit(1);
                  } /* if out of north/south */
               indx = rndnum(uscount,sd);
               north3 = us[indx];
               while (indx < uscount)
                  {
                  us[indx] = us[indx+1];
                  indx++;
                  } /* shift left */
               uscount--;
               if (uscount < 0)
                  {
                  fprintf(stderr,"Side B Out of "
                     "north/south (north3)\n");
                  exit(1);
                  } /* if out of north/south */
               indx = rndnum(themcount,sd);
               south1 = them[indx];
               while (indx < themcount)
                  {
                  them[indx] = them[indx+1];
                  indx++;
                  } /* shift left */
               themcount--;
               if (themcount < 2)
                  {
                  fprintf(stderr,"Side B Out of "
                     "north/south (south1)\n");
                  exit(1);
                  } /* if out of north/south */

               rcnthsth1 = srch(north1,south1,rth);
               rcnthsth2 = srch(north2,south1,rth);
               rcnthsth3 = srch(north3,south1,rth);
               if (rcnthsth1 || rcnthsth2 || rcnthsth3)
                  {
                  us[uscount++] = north1;
                  us[uscount++] = north2;
                  us[uscount++] = north3;
                  us[uscount] = -9999;
                  them[themcount++] = south1;
                  them[themcount] = -9999;
                  } /* if duplicate */
               if (uscount > totplayers)
                  {
                  fprintf(stderr,"Side B North "
                     "overflow\n");
                  exit(1);
                  } /* overflow */
               if (themcount > totplayers)
                  {
                  fprintf(stderr,"Side B South1 "
                     "overflow\n");
                  exit(1);
                  } /* overflow */
               } /* north/south loop */
            if (try >= maxtry) break;
            rcnthsth1 = rcnthsth2 = rcnthsth3 = 1;
            maxtry = themcount << 7;
            try = 0;
            while ((rcnthsth1 || rcnthsth2 || rcnthsth3)
               && uscount >= 0
               && themcount > 1
               && try < maxtry)
               {
               try++;
               indx = rndnum(themcount,sd);
               south2 = them[indx];
               while (indx < themcount)
                  {
                  them[indx] = them[indx+1];
                  indx++;
                  } /* shift left */
               themcount--;
               if (themcount < 1)
                  {
                  fprintf(stderr,"Side B Out of "
                     "north/south (south2)\n");
                  exit(1);
                  } /* if out of east/west */

               rcnthsth1 = srch(north1,south2,rth);
               rcnthsth2 = srch(north2,south2,rth);
               rcnthsth3 = srch(north3,south2,rth);
               if (rcnthsth1 || rcnthsth2 || rcnthsth3)
                  {
                  them[themcount++] = south2;
                  them[themcount] = -9999;
                  } /* if duplicate */
               if (themcount > totplayers)
                  {
                  fprintf(stderr,"Side B South2 "
                     "overflow\n");
                  exit(1);
                  } /* overflow */
               } /* south2 loop */
            if (try >= maxtry) break;
            rcnthsth1 = rcnthsth2 = rcnthsth3 = 1;
            maxtry = themcount << 9;
            try = 0;
            while ((rcnthsth1 || rcnthsth2 || rcnthsth3)
               && uscount >= 0
               && themcount > 0
               && try < maxtry)
               {
               try++;
               indx = rndnum(themcount,sd);
               south3 = them[indx];
               while (indx < themcount)
                  {
                  them[indx] = them[indx+1];
                  indx++;
                  } /* shift left */
               themcount--;
               if (themcount < 0)
                  {
                  fprintf(stderr,"Side B Out of "
                     "north/south (south3)\n");
                  exit(1);
                  } /* if out of east/west */

               rcnthsth1 = srch(north1,south3,rth);
               rcnthsth2 = srch(north2,south3,rth);
               rcnthsth3 = srch(north3,south3,rth);
               if (rcnthsth1 || rcnthsth2 || rcnthsth3)
                  {
                  them[themcount++] = south3;
                  them[themcount] = -9999;
                  } /* if duplicate */
               if (themcount > totplayers)
                  {
                  fprintf(stderr,"Side B South3 "
                     "overflow\n");
                  exit(1);
                  } /* overflow */
               } /* south3 loop */
            if (try >= maxtry) break;

            if (!rcnthsth1 && !rcnthsth2 && !rcnthsth3)
               {
               new = (prfmt *) initnode(north1,south1);
               isrt(new,rth,id,round,court,211);
               new = (prfmt *) initnode(north1,south2);
               isrt(new,rth,id,round,court,212);
               new = (prfmt *) initnode(north1,south3);
               isrt(new,rth,id,round,court,213);
               new = (prfmt *) initnode(north2,south1);
               isrt(new,rth,id,round,court,221);
               new = (prfmt *) initnode(north2,south2);
               isrt(new,rth,id,round,court,222);
               new = (prfmt *) initnode(north2,south3);
               isrt(new,rth,id,round,court,223);
               new = (prfmt *) initnode(north3,south1);
               isrt(new,rth,id,round,court,231);
               new = (prfmt *) initnode(north3,south2);
               isrt(new,rth,id,round,court,232);
               new = (prfmt *) initnode(north3,south3);
               isrt(new,rth,id,round,court,233);
               sprintf(rndlst[rndindx++],
                  "%03d %03d 002 %03d %03d %03d %03d %03d %03d",
                  round, court,
                  north1, north2, north3,
                  south1, south2, south3);
               paircount++;
               } /* if successful court */
            else
               {
               break;
               } /* incomplete set */
            } /* for each court in round */
         if (paircount != 2)
            {
            if (round >= roundtbl[totcourts-1]
               && court >= totcourts)
               {
               int lmt;
               if (rndindx & 1) lmt = rndindx - 1;
               else lmt = rndindx;
               for (i=0;i<lmt;i++)
                  {
                  int len,wrtlen,rslt;
                  char buf[256];
                  sprintf(buf,"%04d %s\n",
                     id, rndlst[i]);
                  len = strlen(buf);
                  wrtlen = write(1,buf,len);
                  if (wrtlen != len)
                     {
                     fprintf(stderr,
                        "Error writing to stdout\n");
                     perror("Write error");
                     exit(1);
                     } /* if write err */
                  } /* for each court in rndlst */
               return(0);
               } /* if bigger round */
            break;
            } /* if failed */
         } /* for each round */
      } /* for each id */
   return(0);
   } /* main */
